---
title: Using Navigation Timing
slug: Web/API/Navigation_timing_API/Using_Navigation_Timing
tags:
  - Guide
  - Navigation Timing
  - Navigation Timing API
  - Optimization
  - Performance
---
<div>{{DefaultAPISidebar("Navigation Timing")}}</div>

<p><span class="seoSummary">The Navigation Timing API lets you easily obtain detailed and highly accurate timing information to help isolate performance problems with your site's code or resources.</span> Unlike other tools or libraries, the <a href="/en-US/docs/Web/API/Navigation_timing_API">Navigation Timing API</a> lets you gather information that only the browser can provide at a level of accuracy much improved over other techniques. It also offers the advantage of being able to provide timing information as perceived by the user rather than data that has no correlation to what the user experiences.</p>

<h2 id="Collecting_timing_information">Collecting timing information</h2>

<p>Using the API is as simple as obtaining the {{domxref("Performance")}} object using {{domxref("window.performance")}} and looking up what you need within the object returned. For example, to measure the perceived loading time for a page:</p>

<pre class="brush: js">window.addEventListener("load", function() {
  let now = new Date().getTime();
  let loadingTime = now - performance.timing.navigationStart;

  document.querySelector(".output").innerText =
        loadingTime + " ms";
}, false);</pre>

<p>This code, executed when the {{event("load")}} event occurs, subtracts from the current time the time at which the navigation whose timing was recorded began ({{domxref("PerformanceTiming.navigationStart", "performance.timing.navigationStart")}}), and outputs that information to the screen by inserting it into an element.</p>

<div class="hidden">
<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;div class="output"&gt;
&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css">.output {
  border: 1px solid #bbb;
  font: 16px "Open Sans", "Helvetica", "Arial", sans-serif;
}</pre>
</div>

<p>In tandem with appropriate HTML and CSS, the result is:</p>

<p>{{EmbedLiveSample("Collecting_timing_information", 500, 80)}}</p>

<p>The values listed are for the {{HTMLElement("iframe")}} in which the sample is presented above.</p>

<p>For a list of the available timing values you can look for in {{domxref("PerformanceTiming")}}, see the {{domxref("PerformanceTiming")}} interface's <a href="/en-US/docs/Web/API/PerformanceTiming#Properties">Properties</a> section.</p>

<h2 id="Determining_navigation_type">Determining navigation type</h2>

<p>To put the timing information obtained from {{domxref("PerformanceTiming")}} into the correct perspective, you need to know more about what sort of load operation occurred. In particular, you need to know:</p>

<ul>
 <li>Was this a load or a reload?</li>
 <li>Was this a navigation or a move forward or backward through history?</li>
 <li>How many (if any) redirects were required in order to complete the navigation?</li>
</ul>

<p>This information is provided by the {{domxref("Performance.navigation")}} property, which returns a {{domxref("PerformanceNavigation")}} object that includes the needed information.</p>

<p>Let's add this information to the example above. The new code looks like this:</p>

<pre class="brush: js">window.addEventListener("load", function() {
  let now = new Date().getTime();
  let loadingTime = now - performance.timing.navigationStart;

  output = "Load time: " + loadingTime + " ms&lt;br/&gt;";
  output += "Navigation type: ";

  switch(performance.navigation.type) {
      case PerformanceNavigation.TYPE_NAVIGATE:
        output += "Navigation";
      break;
    case PerformanceNavigation.TYPE_RELOAD:
        output += "Reload";
      break;
    case PerformanceNavigation.TYPE_BACK_FORWARD:
        output += "History";
      break;
    default:
        output += "Unknown";
      break;
  }

  output += "&lt;br/&gt;Redirects: " +
      performance.navigation.redirectCount;
  document.querySelector(".output").innerHTML = output;
}, false);</pre>

<p>This amends the previous example by looking at the contents of the <code>performance.navigation</code> object. {{domxref("PerformanceNavigation.type", "performance.navigation.type")}} indicates what kind of load operation took place: a navigation, a reload, or a shift through the browser's history. We also obtain the number of redirects that were incurred during the navigation from {{domxref("PerformanceNavigation.redirectCount", "performance.navigation.redirectCount")}}. This information is output to the screen just like the page load time was previously: by inserting it into the element with class <code>"output"</code>.</p>

<div class="hidden">
<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;div class="output"&gt;
&lt;/div&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css">.output {
  border: 1px solid #bbb;
  font: 16px "Open Sans", "Helvetica", "Arial", sans-serif;
}</pre>
</div>

<p>With this code in place, the result looks like this:</p>

<p>{{EmbedLiveSample("Determining_navigation_type", 500, 120)}}</p>

<p>The values listed are for the {{HTMLElement("iframe")}} in which the sample is presented.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Navigation_timing_API">Navigation Timing API</a></li>
 <li>{{domxref("window.performance")}}</li>
 <li>{{domxref("Performance")}}, {{domxref("PerformanceTiming")}}, and {{domxref("PerformanceNavigation")}}</li>
</ul>
